Attribute VB_Name = "Module1"
Global Const ACTOR_HEIGHT = 130
Global Const KEY_DOWN As Integer = &H1000
Global Const SND_ASYNC = &H1

Global Const POCONG = 0
Global Const SUNDER = 1
Global Const LAMPIR = 2
Global Const FIRE = 3

Global Const STANDING = 0
Global Const WALKING = 1
Global Const JUMPING = 2
Global Const KICK = 3
Global Const PUNCH = 4
Global Const JUMP_KICK = 5
Global Const DISSAPEAR = 6
Global Const ATTACK = 7
Global Const FALL = 8
Global Const HIT = 9

Type rect
 left As Integer
 right As Integer
 bottom As Integer
 top As Integer
End Type

Type actor_properties
 x As Integer
 y As Integer
 xoffset As Integer
 yoffset As Integer
 Strengh As Integer
 frame As Integer
 wait_frame As Integer
 direction As Integer
 wait_walk As Integer
 status As Integer
 jump_time As Integer
 HP As Integer
 area As rect
 has_hit As Boolean
End Type

Type enemy_properties
 x As Integer
 y As Integer
 width As Integer
 height As Integer
 xoffset As Integer
 yoffset As Integer
 time As Integer
 HP As Integer
 direction As Integer
 frame As Integer
 area As rect
 has_hit As Boolean
 damage As Integer
End Type

Type weapon_properties
 x As Integer
 y As Integer
 flag As Integer
 xoffset As Integer
 yoffset As Integer
End Type

Global Enemy_Type As Integer
Global Story As Boolean
Global area As Integer
Global areaclear(3) As Boolean
Global actor_pos As Integer

Declare Function BitBlt Lib "gdi32" (ByVal hDestDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&) As Long

Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, _
ByVal x As Long, ByVal y As Long, _
ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal xSrc As Long, _
ByVal ySrc As Long, ByVal nSrcWidth As Long, _
ByVal nSrcHeight As Long, ByVal dwRop As Long _
) As Long

Declare Function ChangeDisplaySettings Lib "user32" Alias "ChangeDisplaySettingsA" (lpDevMode As Any, ByVal dwFlags As Long) As Long

Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
        (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer
Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _
                                            (ByVal lpstrCommand As String, _
                                             ByVal lpstrReturnString As String, _
                                             ByVal uReturnLength As Long, _
                                             ByVal hwndCallback As Long) As Long
Sub delay(wait As Long)
Dim lasttick As Long
Dim currenttick As Long

lasttick = GetTickCount
delay_flag = True

Do
 currenttick = GetTickCount
 DoEvents
Loop Until (currenttick - lasttick) > wait

delay_flag = False

End Sub
Sub Backgroundmusic()

mciSendString "open music01.mid alias BGM", 0&, 0, 0
mciSendString "play BGM from 0", 0&, 0, 0

End Sub

Sub CloseBGM()

mciSendString "stop BGM", 0&, 0, 0
mciSendString "close BGM", 0&, 0, 0

End Sub

Sub ServiceBackgroundMusic(Identifier As String)
Dim rt As Long
Dim status As String

status = "                         "
rt = mciSendString("STATUS " & Identifier & " MODE", status, Len(status), 0)
If rt = 0 Then
    status = Trim$(status)
    If left(UCase$(status), Len("STOPPED")) = "STOPPED" Then
        mciSendString "PLAY " & Identifier & " FROM 0", "", 0, 0
    End If
End If

End Sub

Function AreaIntersect(area1 As rect, area2 As rect) As Boolean

If area1.left < area2.right And area1.right > area2.left Then
   If area1.top < area2.bottom And area1.bottom > area2.top Then
      AreaIntersect = True
   Else: AreaIntersect = False
   End If
Else: AreaIntersect = False
End If
      
End Function
